* DPJ JDS response master

*******************************************************
*** ignore 
* "wlowess() not found" 
*** when it appears in the Stata results window 
*******************************************************

capture log close
drop _all
clear mata
clear matrix
* log using kernel_commontrim0.log, replace text
set matsize 800

local basepath = "C:\data\PnK"	// rpj master data path
local p "\1991-92_Round"
* paths to data files
global datapath1 = "`basepath'`p'1" 		// path to round 1 data
*global datapath2 = "`basepath'`p'2"  		// path to round 2 data
*global datapath3 = "`basepath'`p'3"  		// path to round 3 data

global progpath "`basepath'\PnKDoFiles\jdsresponse"

global workingpath "`basepath'\working"

* paths to .do and working files version "a"
*global workingpath1 "`basepath'\working\R1-3a"		// working data files for round 1-3 second version of data
global roodmanpath "`basepath'\roodman"		// path to 2011 Roodman data
*global roodmanpath1 "`basepath'\roodman\2011"		// path to 2011 Roodman data
global pittpath "`basepath'\pitt"		// path to 2011 Roodman data
global villvarspath "`basepath'\1991-92 village"


***************************************************************************************************************
* 1. rejoinder to Pitt
***************************************************************************************************************

********************************************************************
* table 1 Replicate MP's PSM & show problems (Table 1)
********************************************************************
** table 1 & figure 1
* Table 1 is saved as "${workingpath}\table1.csv" - see rows for translation to Table 1 
* Figure 1 is saved as "${workingpath}\figure1.gph" and as memory graph "figure1";to open: Graph use "C:\data\PnK\Working\figure1.gph"       
********************************************************************
do "${progpath}\mp_table1.do"



********************************************************************
** Tables 2, 3, & 4
* Tables 2, 3 & 4 are saved as "${workingpath}\table2/3/4.csv" 
********************************************************************
do "${progpath}\with_control_villages.do"



*******************************************************************
** Figures 2 & 3 - loans by period
* Figures 2 & 3  are saved as "${workingpath}\figure2.gph"   
*******************************************************************
do "${progpath}\loans_by_period.do"



********************************************************************
** Appendix Tables 8 & 9 * - replicates Pitt, 1999, tables 1 & 2
* Pitt, 1999, tables 1 & 2 are in "${workingpath}\tables8N9.csv"
* Rows 1-8 are Table 8
* Rows 9-16 are Table 9
********************************************************************
* land areas by mis-targeted
do "${progpath}\Pitt1999Tables1&2.do"



********************************************************************
** Table 5 & 6 & 10
** figures 4 - 10
** table 5 is in "${workingpath}\table5.txt"
* table 6 is in "${workingpath}\table6.csv"
* table 10 is in "${workingpath}\table10.csv"
* figures 4 - 10 in "${workingpath}\figure4/5/6/7/8/9/10.gph" 
* and memory graphs figure4.5/6/7/8/9/10
********************************************************************
* analysis of land unit values
do "${progpath}\Pitt1999Table3.do"



********************************************************************
** Table 7
* table 7 appears in "${workingpath\}\table7.csv"
********************************************************************
* PSM with alternative non-target variables
do "${progpath}\psm_with_control_villages 2.do" 



********************************************************************
** Tables 1 & 7 for male borrowers -  Appendix 2 Tables 11 & 12
* results in "${workingpath}\table11/12.csv 
* the balancing figure 9 equivalent to Figure 1 is in "${workingpath}figure1_male.gph"
********************************************************************
do "${progpath}\psm_malehh.do" // male borrowers




