*******************************************************************
* loans are bunched in 1990-1992                                  *
*******************************************************************


* all loans and wave 1 loans only
* probably should exclude loans after some monthys befoere start of reound 1!

* all loans
*use nh pid progid sex agey weight lnconsweekpc l*y*_pp wave1_l*pp*  using "${workingpath1}\psm_prep_all 2.dta", clear
*save "${workingpath}\loans_by_period.dta", replace
qui {

clear all

use "${workingpath}\loans_by_period.dta", clear

* reg of consumption vs year of loan
* create variables for amount borrowed from brogram by year, and whether loan in year
forval y = 82/92 {
	egen prog_loan_sum_`y' = rowtotal(l2y`y'_pp l3y`y'_pp l4y`y'_pp)
	gen prog_loan_`y' = prog_loan_sum_`y' > 0
	gen formal_loan_sum_`y' = l1y`y'_pp 
	gen formal_loan_`y' = formal_loan_sum_`y' > 0
	egen informal_loan_sum_`y' = rowtotal(l5y`y'_pp l6y`y'_pp)
	gen informal_loan_`y' = informal_loan_sum_`y' > 0
        egen wave1_prog_loan_sum_`y' = rowtotal(wave1_l2y`y'_pp wave1_l3y`y'_pp wave1_l4y`y'_pp)
	gen  wave1_prog_loan_`y' = prog_loan_sum_`y' > 0
	gen  wave1_formal_loan_sum_`y' = wave1_l1y`y'_pp
	gen  wave1_formal_loan_`y' = wave1_formal_loan_sum_`y' > 0
	egen wave1_informal_loan_sum_`y' = rowtotal(wave1_l5y`y'_pp wave1_l6y`y'_pp)
	gen  wave1_informal_loan_`y' = wave1_informal_loan_sum_`y' > 0
}

reg lnconsweekpc  prog_loan_82 prog_loan_83 prog_loan_84 prog_loan_85 prog_loan_86 prog_loan_87 prog_loan_88 prog_loan_89 prog_loan_90 prog_loan_91 prog_loan_92, nocons
reg lnconsweekpc  prog_loan_sum*, nocons

label def progid 1 "BRAC" 2 "BRDB" 3 "GB" 4 "Eligible Non-member" 5 "Ineligible/Control"
label val progid progid

keep progid nh pid sex agey prog_loan* formal_loan* informal_loan* wave1_prog_loan* wave1_formal_loan* wave1_informal_loan*  weight
keep if agey >= 15 & agey <= 70

reshape long prog_loan_sum_  prog_loan_ ///
	formal_loan_sum_ formal_loan_ ///
	informal_loan_sum_ informal_loan_ ///
	wave1_prog_loan_sum_  wave1_prog_loan_ ///
	wave1_formal_loan_sum_ wave1_formal_loan_ ///
	wave1_informal_loan_sum_ wave1_informal_loan_ ///
	, i(nh pid) j(year)

collapse (sum) num_prog_loans = prog_loan_ num_formal_loans = formal_loan_ num_informal_loans = informal_loan_ ///
	(sum) sum_prog_loans = prog_loan_sum_ sum_formal_loans = formal_loan_sum_ sum_informal_loans = informal_loan_sum_ ///
	(sum) wave1_num_prog_loans = wave1_prog_loan_ wave1_num_formal_loans = wave1_formal_loan_ wave1_num_informal_loans = wave1_informal_loan_ ///
	(sum) wave1_sum_prog_loans = wave1_prog_loan_sum_ wave1_sum_formal_loans = wave1_formal_loan_sum_ wave1_sum_informal_loans = wave1_informal_loan_sum_ ///
	[weight = weight] , by(year progid sex)
	
* loan sources - all rounds
gr bar num_prog_loans num_formal_loans num_informal_loans if sex == 1,  over(year, label( labsize(tiny)))  over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(male)  ///
	ylabel( ,angle(45) labsize(tiny)) name(numloans_male, replace) nodraw

gr bar num_prog_loans num_formal_loans num_informal_loans if sex == 2,  over(year, label( labsize(tiny)))  over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(female)  ///
	ylabel( ,angle(45) labsize(tiny)) name(numloans_female, replace) nodraw
/*	
gr combine numloans_female numloans_male, rows(2) ///
	note("number of loans", size(vsmall))
*/

* graph by individual MFI loan sources - loans in all rounds
* figure not reported
grc1leg numloans_female numloans_male, legendfrom(numloans_female) pos(6) span rows(2) imargin(zero)

/*
gr bar sum_prog_loans sum_formal_loans sum_informal_loans, ///
	over(year, label( labsize(tiny)))  over(progid, label( labsize(small)) ) ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(total loan value) ///
	ylabel( ,angle(45) labsize(tiny)) 
	
*/

* pool all MFI loan sources - all loans
gr bar num_prog_loans num_formal_loans num_informal_loans if sex == 1,  over(year, label( labsize(tiny)))  /// over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(male)  ///
	ylabel( ,angle(45) labsize(tiny)) name(numloans_male, replace) nodraw

gr bar num_prog_loans num_formal_loans num_informal_loans if sex == 2,  over(year, label( labsize(tiny))) ///  over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(female)  ///
	ylabel( ,angle(45) labsize(tiny)) name(numloans_female, replace) nodraw

**************************************************************************************************
* Figure 2 - all loans
* NOT REPORTED - see Figure 2 below
**************************************************************************************************
grc1leg numloans_female numloans_male, legendfrom(numloans_female) pos(6) span rows(2) imargin(zero) name("figure2a", replace)

**************************************************************************************************
* Figure 3 - all loans
* NOT REPORTED
**************************************************************************************************
gr bar sum_prog_loans sum_formal_loans sum_informal_loans, ///
	over(year, label( labsize(tiny))) /// over(progid, label( labsize(small)) ) ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(total loan value) ///
	ylabel( ,angle(45) labsize(tiny)) name("figure3a", replace)

tabstat sum_prog_loans sum_formal_loans sum_informal_loans , by(year) s(sum)

* Ian Watson's tabout ....(http://www.ianwatson.com.au/stata/tabout_tutorial.pdf)
* tabout year using "${workingpath}\table1a.txt" , c(sum sum_prog_loans sum sum_formal_loans sum sum_informal_loans) f(0c)  sum   replace h3(nil) npos(both)

* pool all MFI loan sources - round1 loans only loans
gr bar wave1_num_prog_loans wave1_num_formal_loans wave1_num_informal_loans if sex == 1,  over(year, label( labsize(tiny)))  /// over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(male)  ///
	ylabel( ,angle(45) labsize(tiny)) name(wave1_numloans_male, replace) nodraw

gr bar wave1_num_prog_loans wave1_num_formal_loans wave1_num_informal_loans if sex == 2,  over(year, label( labsize(tiny))) ///  over(progid, label( labsize(small)) )  ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(female)  ///
	ylabel( ,angle(45) labsize(tiny)) name(wave1_numloans_female, replace) nodraw

} // end quiet

**************************************************************************************************
* Figure 2 - round 1 loans only loans
**************************************************************************************************
grc1leg wave1_numloans_female wave1_numloans_male, legendfrom(wave1_numloans_female) pos(6) ///
	span rows(2) imargin(zero) name("figure2", replace) saving("${workingpath}\figure2.gph", replace)

**************************************************************************************************
* Figure 3 - round1 loans
**************************************************************************************************
gr bar wave1_sum_prog_loans wave1_sum_formal_loans wave1_sum_informal_loans, ///
	over(year, label( labsize(tiny))) /// over(progid, label( labsize(small)) ) ///
	legend(label(1 "program") label(2 "formal") label(3 "informal") rows(1) size(vsmall)) ///
	title(total loan value) ///
	ylabel( ,angle(45) labsize(tiny)) name("figure3", replace)  saving("${workingpath}\figure3.gph", replace)

