* routines used in jds_response 

* programs to recover results
cap prog drop store 
program define store 
* resutls from msmatch2 kernel
* syntax store row matname // where title is estimates stored title
local i = `1'
	mat N = e(N)
	local n = N[1,1]
	local diff = r(att)	 // extract att & seatt and store in results matrix
	local semean = r(seatt)
*	local i = 1
	mat `2'[`i', 1] = `n'
	mat `2'[`i', 2] = `diff'
	mat `2'[`i', 3] = `semean'
	local sd = `semean' * sqrt(`diff')
	qui sum _treated			// extract  p- & t-values
	local n = r(sum) - 1
	local pdiff = 2*ttail(`n', abs(`diff'/`semean'))
	local tdiff = `diff' / `semean'
	mat `2'[`i', 4] = `pdiff'
	mat `2'[`i', 5] = `tdiff'
end

cap prog drop store1 
program define store1 
* resutls from bnootstral pasmatch2 kernel
*syntax store1 row matrix
set trace on
args i results
	mat N = e(N)
	local n = N[1,1]
	mat b = e(b)
	local b = b[1,1]	 // extract att & seatt and store in results matrix
	mat se = e(se)
	local seb = se[1,1]
	local t = `b' / `seb'
	local n = e(N)
	local p = 2 * ttail(`n', abs(`t'))
	mat ci = e(ci_normal)
*	local i = 1
	mat `results'[`i', 1] = `N'
	mat `results'[`i', 2] = `b'
	mat `results'[`i', 3] = `seb'
	mat `results'[`i', 4] = `p'
	mat `results'[`i', 5] = `t'
	mat `results'[`i', 6] = ci[1,1]
	mat `results'[`i', 7] = ci[2,1]
end

* store results after psmatch2 with pscore() option
cap prog drop store2 
program define store2 
* resutls from  pasmatch2 with pscore() nearest neighbour
*syntax store2 row matrix
*set trace on
args i results
	mat N = e(N)
	local n = N[1,1]
	mat b = r(att)
	local b = b[1,1]	 // extract att & seatt and store in results matrix
	mat se = r(seatt)
	local seb = se[1,1]
	local t = `b' / `seb'
	local p = 2 * ttail(`n', abs(`t'))
	mat ci = e(ci_normal)
*	local i = 1
	mat `results'[`i', 1] = `n'
	mat `results'[`i', 2] = `b'
	mat `results'[`i', 3] = `seb'
	mat `results'[`i', 4] = `p'
	mat `results'[`i', 5] = `t'
	mat `results'[`i', 6] = ci[1,1]
	mat `results'[`i', 7] = ci[2,1]
end


cap prog drop sa_results
prog def sa_results, rclass
args r1 sa_results results1
* get results or rsens
tempname results
mat `results' = `sa_results'
local rows = rowsof(`results')
sca ns10u = 0
sca ns10l = 0
sca gamma = 1
forval r = 1/`rows' {
	noisily di "`r'"
	if `results'[1, 3] <= 0.1 {	// SOMETIMES RSENS RETURNS LARGER VALUES
		if `results'[`r', 3]  > 0.1 {
			sca gamma = `results'[`r', 1]
			sca ns10u = `results'[`r', 2]
			sca ns10l = `results'[`r', 3] 
			continue, break
		}
		if `results'[`r', 2]  > 0.1 {
			sca gamma = `results'[`r', 1]
			sca ns10l = `results'[`r', 2] 
			sca ns10u = `results'[`r', 3]
			continue, break
		}
	}
	if `results'[1, 3] >= 0.1 { // SEARCH TILL ONE OF THE VALUES BECOMES VERY SMALL
		
		if `results'[`r', 3]  < 0.0001 {
			sca gamma = `results'[`r', 1]
			sca ns10u = `results'[`r', 2]
			sca ns10l = `results'[`r', 3] 
			continue, break
		}
		if `results'[`r', 2]  <= 0.0001 {
			sca gamma = `results'[`r', 1]
			sca ns10l = `results'[`r', 2] 
			sca ns10u = `results'[`r', 3]
			continue, break
		}
	}
	
}
di "lower  " ns10l "   upper  " ns10u
mat `results1'[`r1', 6] = gamma
mat `results1'[`r1', 7] = ns10l
mat `results1'[`r1', 8] = ns10u

return mat sa_results = `results'
end

* qqgraph

* plot qqplot after matching

*********need to plot before as well as after
cap prog drop qqgraph
program define qqgraph
version 10.0
syntax varlist (min=1), treatment(varname) weight(varname)  [precision(real 0.01) ] Name(passthru)
tempname original
local var `varlist'
preserve
	replace `weight' = round(`precision'*`weight') if `weight'!=.
	qui expand `weight', gen(`original')
	qui replace `original' = !`original'


foreach var of varlist `varlist' {
	tempname qut quc qmt qmc 
	
* Calculate deviation from the 45 degree QQ plot line in terms of mean and max
	

	qui cquantile `var' if `original', by(`treatment') gen(`qut' `quc')
	
	qqplot `qut' `quc', title("`var'") name("before", replace) nodraw //  `name' 
	
	qui cquantile `var' if `weight'!=., by(`treatment') gen(`qmt' `qmc')

	qqplot `qmt' `qmc', title("`var'") name("after", replace) nodraw // `name' 
	gr combine before after, xcommon ycommon rows(2) xsize(7.6) ysize(10.7) name(`var', replace)
}

restore
end

* store outcomes of "test"
cap prog drop tWp
program define tWp 
	test  0.target`1'#1.participant = 1.target`1'#1.participant	// target within participants
	estadd sca tWp = r(p) 
	test  0.target`1'#0.participant = 1.target`1'#0.participant	// target within non-participants
	estadd sca tWnp = r(p) 
	test  1.target`1'#0.participant = 1.target`1'#1.participant // participants within target
	estadd sca pWt = r(p) 
	test  0.target`1'#0.participant = 0.target`1'#1.participant	// participants within non-target
	estadd sca pWnt= r(p) 
end

cap prog drop tWp2
program define tWp2 
	test  0.nontarget`1'#1.nonclient = 1.nontarget`1'#1.nonclient	// target within nonclients
	estadd sca tWp = r(p) 
	test  0.nontarget`1'#0.nonclient = 1.nontarget`1'#0.nonclient	// target within non-nonclients
	estadd sca tWnp = r(p) 
	test  1.nontarget`1'#0.nonclient = 1.nontarget`1'#1.nonclient // nonclients within target
	estadd sca pWt = r(p) 
	test  0.nontarget`1'#0.nonclient = 0.nontarget`1'#1.nonclient	// nonclients within non-target
	estadd sca pWnt= r(p) 
end


* Roodman's weighted lowess
mata
mata set matalnum off
mata set mataoptimize on
// Routine to do lowess regressions with sampling weights. Variable [xbname] must exist before calling and will be overwritten.
// Ditto for [stdpname] unless it is "" in which case standard error of prediction is not returned
// Formulas from Stata manual entry for -lowess-.
// Data must be sorted by [xname]
mata drop wlowess()
void wlowess(string scalar yname, string scalar xname, string scalar wname, real scalar bw, string scalar xbname, string scalar stdpname, | string scalar selectvarname) {
	real scalar N, k, i, xi, imin, imax, Delta; real matrix data, XX; real colvector beta, Y, X, W, xb, stdp, E
	pragma unset X; pragma unset Y; pragma unset xb; pragma unset data; pragma unset stdp
	st_view(data, ., strlen(stdpname)? (xname, yname, wname, xbname, stdpname): (xname, yname, wname, xbname), selectvarname)
	N = rows(data)
	st_subview(xb, data, ., 4)
	if (strlen(stdpname))
		st_subview(stdp, data, ., 5)
	k = trunc((N * bw - .5) / 2)
	for (i=N; i; i--) {
		xi = data[i,1]
		imin = max((1, i-k)); imax = min((i+k, N))
		if (Delta = 1.0001 * max((data[imax,1] - xi, xi - data[imin,1]))) {
			st_subview(X, data, (imin, imax), 1)
			st_subview(Y, data, (imin, imax), 2)
			W = data[|imin, 3 \ imax, 3|] :* (1 :- (abs(X :- xi)/Delta):^3):^3
			beta = (XX = cholinv(cross(X, 1, W, X, 1))) * cross(X, 1, W, Y, 0)
			xb[i] = data[i,1] * beta[1] + beta[2]
			if (strlen(stdpname)) {
				E = (Y - X * beta[1]) :- beta[2]
				stdp[i] = sqrt((cross(E, W, E)/sum(W)*N/(N-1)) * ((XX[1,1]*xi + 2*XX[1,2])*xi + XX[2,2])) // stdp = sig2*N/(N-1) * X_i * (X'X)^-2 * X_i' where X_i includes 1
			}
		}
	}
}
end

cap program drop wlowess
program define wlowess, sortpreserve
	syntax varlist(ts) [if] [in] [pw fw aw iw], xb(string) [stdp(string) bw(real 0.8)]
	marksample touse
	if "`weight'" != "" {
		tempvar wvar
		qui gen double `wvar' `exp' if `touse'
	}
	else {
		noi di as err "No weights."
		error 1
	}
	qui gen double `xb' = .
	if "`stdp'" != "" qui gen double `stdp' = .
	tsrevar `varlist'
	tokenize `r(varlist)'
	sort `2'
	mata wlowess("`1'", "`2'", "`wvar'", `bw', "`xb'", "`stdp'", "`touse'")
end

