

* prepare PKexp by correcting wvill etc.
use "${pittpath}\PKexp", clear
sort nh round
replace loghland = ln(123) if nh == 32111	/* error in data for this household */

gen _Wwvill_11 = vill == 11 
gen _Wwvill_143 = vill == 143 
replace wchoice = 1 if vill == 143 & nontrgth == 0
gen _Mmvill_11 = vill == 11 
gen _Mmvill_53 = vill == 53 

gen outliers = inlist(nh, 32014, 52121, 72025, 82915, 83015, 113035, 121042, 132042, 133035, 231015, 231015, 231025, 231025, 281035, 282064)

* not used in psm  - used in cmp
gen byte indf = wchoice * (1 + (creditf <= 0))	// indicator of female - 0 = no choice, 1 = non borrower in village with female group; 2 = female borrower)
gen byte indm = mchoice * (1 + (creditm <= 0))
*

gen thana=int(vill/10)
xi i.thana, noomit
unab dummies: _Ithana*
gen credit = creditf > 0 | creditm > 0
gen creditff = creditf > 0
gen creditmm = creditm > 0 // rpj

* drop if thana > 24 /* keep all thana */

* egen wvill=rowmean(_W*) // change to rowmax
* egen mvill=rowmean(_M*)
egen wvill=rowmax(_W*)
egen mvill=rowmax(_M*)

* credit in any round
gen fhh_ = creditff > 0
gen mhh_ = creditmm > 0
bys nh (round) : egen fhh = max(fhh_)
bys nh (round) : egen mhh = max(mhh_)
label var fhh "household has female credit - any round"
label var mhh "household has male credit - any round"

* some households get credit for first time in rounds 2 & 3 only
gen fhh1_ = creditff > 0 & round == 1	// household with female credit in round 1
gen mhh1_ = creditmm > 0 & round == 1	// household with male credit in round 1
bys nh : egen fhh1 = max(fhh1_)
bys nh : egen mhh1 = max(mhh1_)
gen fhh2_ = creditf > 0 & round >= 2 & fhh1 == 0	// households with female credit in rounds 2 & 3 but not round 1
gen mhh2_ = creditm > 0 & round >= 2 & mhh1 == 0	// households with male credit in rounds 2 & 3 but not round 1
bys nh : egen fhh2 = max(fhh2_)
bys nh : egen mhh2 = max(mhh2_)

label var fhh1 "household has female  credit in round1"
label var mhh1 "household has male  credit in round1"
label var fhh2 "household has female  credit first in rounds 2 or 3"
label var mhh2 "household has male  credit first in rounds 2 or 3"

tab vil if fhh2 == 1
tab vil if round == 1  & fhh2 == 1
* 28 households get loans for first time in waves 2 & 3 


tab nh fhh2 if round == 1 & fhh2 == 1, matrow(row) matcell(cell)
mat list row
* manually get list of hh which borrow in rounds 2 & 3
/* 22051, 23081, 31101, 31131, 32071, 32081, 33031, 52041, 52101, 73141, 91014, 91032, 91042, 102042, 102072, 102082, 102092, 111012, 111022, 111082, 113022, 113072, 132042, 142082, 142092, 142102, 142172, 151062) */
 * get list of households 
local list
local r = rowsof(row)
forval i = 1/`r' {
	local nh = row[`i', 1]
	if `i' == 1 { 
		local list = "`nh', "
	}
	else if `i' < `r' {
		local list = "`list' `nh', "
	}
	else {
		local list = "`list' `nh'"
	}
*	di "`list'"
}
di "	`list'"
gen fborr_r2N3 : "household female borroer first rounds 2 or 3 " = inlist(nh, `list')

* villages with any female borrowing
bys vill (nh round): egen f_vill = max(creditff)
bys vill (nh round): egen m_vill = max(creditmm)

* female credit prior to survey
bys vill (nh round): egen f_vill1 = max(fhh1)
bys vill (nh round): egen m_vill1 = max(mhh1)
* this is better, however, village 111 (3 female loans in 1990), 113 (2 female 

**************************************************************
* need to include only 111 & 143 as others have too few loans
**************************************************************

* eligible per village
gen choice = wchoice | mchoice

set seed 50581123
gen gg=uniform()
sort gg